import React from 'react';
import { Options as ReactMarkdownOptions } from 'react-markdown';
import './Preview.less';
export interface PreviewInstance {
    getMarkdown(): string;
    setMarkdown(markdown: string): void;
    debounceSetMarkdown(markdown: string): void;
    setMarkdownOptions(markdownOptions: Partial<ReactMarkdownOptions>): void;
    getContainer(): HTMLDivElement | null;
    getHast(): any;
}
export interface PreviewProps {
    /**
     * @description 自定义渲染
     */
    render?(markdown: string): React.ReactNode;
    /**
     * @description 刷新间隔
     * @default 1000
     */
    interval?: number;
    /**
     * @description 自动更新（默认当显示预览时为true，否则为false）
     */
    shouldUpdate?: boolean;
    /**
     * @description [remark 插件](https://github.com/remarkjs/react-markdown#plugins)
     */
    remarkPlugins?: ReactMarkdownOptions['remarkPlugins'];
    /**
     * @description [rehype 插件](https://github.com/remarkjs/react-markdown#plugins)
     */
    rehypePlugins?: ReactMarkdownOptions['rehypePlugins'];
    /**
     * @description [react-markdown 选项](https://github.com/remarkjs/react-markdown)
     */
    markdownOptions?: Partial<ReactMarkdownOptions>;
}
declare const _default: React.MemoExoticComponent<React.ForwardRefExoticComponent<PreviewProps & React.RefAttributes<PreviewInstance>>>;
export default _default;
