var _excluded = ["node", "inline", "className", "children"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { forwardRef, useImperativeHandle, useMemo, useRef, useState } from 'react';
import classnames from 'classnames';
import debounce from 'lodash/debounce';
import ReactMarkdown from 'react-markdown';
import remarkGfm from 'remark-gfm';
import remarkBreaks from 'remark-breaks';
import rehypeRaw from 'rehype-raw';
import rehypeSanitize, { defaultSchema } from 'rehype-sanitize';
import { PrismAsyncLight as SyntaxHighlighter } from 'react-syntax-highlighter';
import hljsStyle from 'react-syntax-highlighter/dist/esm/styles/prism/prism';
import useRehype from './hooks/useRehype';
import "./Preview.css";
var Preview = /*#__PURE__*/forwardRef(function (props, ref) {
  var _defaultSchema$attrib, _defaultSchema$attrib2;

  var containerRef = useRef(null);
  var render = props.render,
      _props$interval = props.interval,
      interval = _props$interval === void 0 ? 1000 : _props$interval,
      _props$remarkPlugins = props.remarkPlugins,
      remarkPlugins = _props$remarkPlugins === void 0 ? [] : _props$remarkPlugins,
      _props$rehypePlugins = props.rehypePlugins,
      rehypePlugins = _props$rehypePlugins === void 0 ? [] : _props$rehypePlugins;

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      markdown = _useState2[0],
      setMarkdown = _useState2[1];

  var _useState3 = useState(props.markdownOptions || {}),
      _useState4 = _slicedToArray(_useState3, 2),
      markdownOptions = _useState4[0],
      setMarkdownOptions = _useState4[1];

  var debounceSetMarkdown = useMemo(function () {
    return debounce(setMarkdown, interval);
  }, [interval]);

  var _useRehype = useRehype(),
      _useRehype2 = _slicedToArray(_useRehype, 2),
      rehypePlugin = _useRehype2[0],
      hastRef = _useRehype2[1];

  useImperativeHandle(ref, function () {
    return {
      getMarkdown: function getMarkdown() {
        return markdown;
      },
      setMarkdown: setMarkdown,
      debounceSetMarkdown: debounceSetMarkdown,
      setMarkdownOptions: setMarkdownOptions,
      getContainer: function getContainer() {
        return containerRef.current;
      },
      getHast: function getHast() {
        return hastRef.current;
      }
    };
  }, [markdown, debounceSetMarkdown]);
  return /*#__PURE__*/React.createElement("div", {
    ref: containerRef,
    className: "pf-mde-preview-content"
  }, (render === null || render === void 0 ? void 0 : render(markdown)) || /*#__PURE__*/React.createElement(ReactMarkdown, _objectSpread({
    children: markdown,
    remarkPlugins: [remarkGfm, remarkBreaks].concat(_toConsumableArray(remarkPlugins)),
    rehypePlugins: [rehypeRaw, [rehypeSanitize, _objectSpread(_objectSpread({}, defaultSchema), {}, {
      attributes: _objectSpread(_objectSpread({}, defaultSchema.attributes), {}, {
        code: [].concat(_toConsumableArray(((_defaultSchema$attrib = defaultSchema.attributes) === null || _defaultSchema$attrib === void 0 ? void 0 : _defaultSchema$attrib.code) || []), ['className']),
        span: [].concat(_toConsumableArray(((_defaultSchema$attrib2 = defaultSchema.attributes) === null || _defaultSchema$attrib2 === void 0 ? void 0 : _defaultSchema$attrib2.span) || []), ['className', 'title'])
      })
    })]].concat(_toConsumableArray(rehypePlugins), [rehypePlugin]),
    components: {
      code: function code(_ref) {
        var node = _ref.node,
            inline = _ref.inline,
            className = _ref.className,
            children = _ref.children,
            props = _objectWithoutProperties(_ref, _excluded);

        if (inline) {
          return /*#__PURE__*/React.createElement("code", _objectSpread({
            className: classnames(className, 'pf-mde-inline-code')
          }, props), children);
        }

        var match = /language-(\w+)/.exec(className || '');

        if (match) {
          return /*#__PURE__*/React.createElement(SyntaxHighlighter, _objectSpread({
            children: String(children).replace(/\n$/, ''),
            style: hljsStyle,
            customStyle: {
              borderRadius: 4,
              background: '#f6f8fa'
            },
            language: match[1],
            PreTag: "div"
          }, props));
        }

        return /*#__PURE__*/React.createElement("div", {
          className: "pf-mde-block-code"
        }, /*#__PURE__*/React.createElement("code", _objectSpread({
          className: className
        }, props), children));
      }
    }
  }, markdownOptions)));
});
export default /*#__PURE__*/React.memo(Preview, function (prevProps, nextProps) {
  return !nextProps.shouldUpdate || prevProps.interval === nextProps.interval;
});