import React from 'react';
import type { KeyBinding } from '@codemirror/view';
import './Toolbar.less';
export interface ToolbarInstance {
    setButtonState(buttonState: ButtonState): void;
    setKeymap(keymap: KeyBinding[]): void;
    extraCommandKeys(commandKeys: Record<string, string>): void;
}
export declare type BuiltInButton = 'undo' | 'redo' | 'bold' | 'italic' | 'strikethrough' | 'heading' | 'quote' | 'code' | 'table' | 'line' | 'unorderedList' | 'orderedList' | 'link' | 'image' | 'preview' | 'editorPreview' | 'fullScreen';
export declare type ButtonState = {
    [type in BuiltInButton]?: boolean;
};
export declare type ToolbarButton = BuiltInButton | '|' | {
    type: BuiltInButton | '|' | 'custom';
    render?: () => React.ReactNode;
};
export interface ToolbarProps {
    /**
     * @description 工具条菜单按钮
     */
    buttons: ToolbarButton[];
    /**
     * @description 菜单按钮点击事件回调
     */
    onButtonClick?: (type: BuiltInButton) => void;
}
declare const Toolbar: React.ForwardRefExoticComponent<ToolbarProps & React.RefAttributes<ToolbarInstance>>;
export default Toolbar;
