function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useRef, useState } from 'react';
export default (function (state) {
  var editorPreviewEnableFullScreen = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var displayModeRef = useRef(_objectSpread({
    fullScreen: false,
    preview: false,
    editorPreview: false
  }, state));

  var _useState = useState(displayModeRef.current),
      _useState2 = _slicedToArray(_useState, 2),
      setModeState = _useState2[1];

  var toggleFullScreen = function toggleFullScreen(fullScreen) {
    var _fullScreen;

    (_fullScreen = fullScreen) !== null && _fullScreen !== void 0 ? _fullScreen : fullScreen = !displayModeRef.current.fullScreen;
    var preview = displayModeRef.current.preview;
    var editorPreview = editorPreviewEnableFullScreen ? false : displayModeRef.current.editorPreview;
    displayModeRef.current = {
      fullScreen: fullScreen,
      preview: preview,
      editorPreview: editorPreview
    };
    setModeState(displayModeRef.current);
    return true;
  };

  var togglePreview = function togglePreview(preview) {
    var _preview;

    (_preview = preview) !== null && _preview !== void 0 ? _preview : preview = !displayModeRef.current.preview;
    var fullScreen = displayModeRef.current.fullScreen;
    var editorPreview = false;
    displayModeRef.current = {
      fullScreen: fullScreen,
      preview: preview,
      editorPreview: editorPreview
    };
    setModeState(displayModeRef.current);
    return true;
  };

  var toggleEditorPreview = function toggleEditorPreview(editorPreview) {
    var _editorPreview;

    (_editorPreview = editorPreview) !== null && _editorPreview !== void 0 ? _editorPreview : editorPreview = !displayModeRef.current.editorPreview;
    var fullScreen = editorPreviewEnableFullScreen;
    var preview = false;
    displayModeRef.current = {
      fullScreen: fullScreen,
      preview: preview,
      editorPreview: editorPreview
    };
    setModeState(displayModeRef.current);
    return true;
  };

  return [displayModeRef, toggleFullScreen, togglePreview, toggleEditorPreview];
});