interface UploadConfig {
    url: string;
    name?: string;
    allowedTypes?: string | string[];
    timeout?: number;
    headers?: HeadersInit;
    data?: object | ((file: File) => object | Promise<object>);
    withCredentials?: boolean;
    beforeUpload?: (file: File) => boolean | Promise<File>;
    transform?: (res: object | string, xhr: XMLHttpRequest) => {
        url: string;
        title?: string;
    };
    onSuccess?: (res: object | string, xhr: XMLHttpRequest, file: File) => void;
    onError?: (xhr: XMLHttpRequest, file: File) => void;
}
declare const upload: (config: UploadConfig) => import("@codemirror/state").Extension;
export default upload;
