function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import { EditorView } from '@codemirror/view';

var Uploader = /*#__PURE__*/function () {
  function Uploader(config) {
    _classCallCheck(this, Uploader);

    this.config = void 0;
    this.template = '[${uid}${text}]()';
    this.index = 0;
    this.queue = [];
    this.config = config;
  }

  _createClass(Uploader, [{
    key: "intervalQueue",
    value: function intervalQueue(fn) {
      var _this = this;

      this.queue.push(fn);

      var handleQueue = function handleQueue() {
        if (_this.queue.length > 0) {
          _this.queue[0]();

          setTimeout(function () {
            _this.queue.shift();

            handleQueue();
          }, 1);
        }
      };

      if (this.queue.length === 1) {
        handleQueue();
      }
    }
  }, {
    key: "isFileAllowed",
    value: function isFileAllowed(file) {
      var _this$config$allowedT = this.config.allowedTypes,
          allowedTypes = _this$config$allowedT === void 0 ? '*' : _this$config$allowedT;
      return [allowedTypes].flat().some(function (pattern) {
        return new RegExp("^".concat(pattern.replace('*', '.*'))).test(file.type);
      });
    }
  }, {
    key: "isImage",
    value: function isImage(file) {
      return /image/.test(file.type);
    }
  }, {
    key: "prepareFiles",
    value: function prepareFiles(files) {
      var fileList = [];

      var _iterator = _createForOfIteratorHelper(files),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var file = _step.value;

          if (!this.isFileAllowed(file)) {
            continue;
          }

          if (!Object.isFrozen(file)) {
            this.index++;
            file.uid = this.index.toString().padStart(3, '0');
          }

          fileList.push(file);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return fileList;
    }
  }, {
    key: "parseTemplate",
    value: function parseTemplate(file) {
      var text = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var content = this.template.replace('${uid}', file.uid || '').replace('${text}', text);
      return this.isImage(file) ? '!' + content : content;
    }
  }, {
    key: "existTemplateContent",
    value: function existTemplateContent(file, view) {
      var regexpString = this.parseTemplate(file, '.*').replace(/[!\[\]()]/g, '\\$&');
      return new RegExp(regexpString, 'g').test(view.state.doc.toString());
    }
  }, {
    key: "updateTemplateContent",
    value: function updateTemplateContent(content, file, view) {
      var doc = view.state.doc.toString();
      var regexpString = this.parseTemplate(file, '.*').replace(/[!\[\]()]/g, '\\$&');

      if (!content) {
        regexpString += '\n{0,2}';
      }

      var regexp = new RegExp(regexpString, 'g');
      var match;
      var changes = [];

      while ((match = regexp.exec(doc)) !== null) {
        changes.push({
          from: match.index,
          to: regexp.lastIndex,
          insert: content
        });
      }

      if (changes.length > 0) {
        view.dispatch({
          changes: changes,
          userEvent: 'input'
        });
        return true;
      }

      return false;
    }
  }, {
    key: "uploadFiles",
    value: function () {
      var _uploadFiles = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(files, view) {
        var _this2 = this;

        var fileList, _iterator2, _step2, file;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                fileList = this.prepareFiles(files);

                if (!(fileList.length < 1)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                this.intervalQueue(function () {
                  var insertList = fileList.map(function (file) {
                    return _this2.parseTemplate(file, ' waiting...');
                  });
                  var changes = view.state.replaceSelection([].concat(_toConsumableArray(insertList), ['']).join('\n\n'));
                  view.dispatch(changes, {
                    userEvent: 'input'
                  });
                });
                _iterator2 = _createForOfIteratorHelper(fileList);
                _context.prev = 5;

                _iterator2.s();

              case 7:
                if ((_step2 = _iterator2.n()).done) {
                  _context.next = 18;
                  break;
                }

                file = _step2.value;
                _context.prev = 9;
                _context.next = 12;
                return this.upload(file, view);

              case 12:
                _context.next = 16;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context["catch"](9);

              case 16:
                _context.next = 7;
                break;

              case 18:
                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t1 = _context["catch"](5);

                _iterator2.e(_context.t1);

              case 23:
                _context.prev = 23;

                _iterator2.f();

                return _context.finish(23);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 20, 23, 26], [9, 14]]);
      }));

      function uploadFiles(_x, _x2) {
        return _uploadFiles.apply(this, arguments);
      }

      return uploadFiles;
    }()
  }, {
    key: "upload",
    value: function () {
      var _upload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(file, view) {
        var _this3 = this;

        var _this$config, url, _this$config$name, name, _this$config$timeout, timeout, _this$config$headers, headers, _this$config$data, data, withCredentials, beforeUpload, onError, _file;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(typeof XMLHttpRequest === 'undefined')) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                _this$config = this.config, url = _this$config.url, _this$config$name = _this$config.name, name = _this$config$name === void 0 ? 'file' : _this$config$name, _this$config$timeout = _this$config.timeout, timeout = _this$config$timeout === void 0 ? 60000 : _this$config$timeout, _this$config$headers = _this$config.headers, headers = _this$config$headers === void 0 ? {} : _this$config$headers, _this$config$data = _this$config.data, data = _this$config$data === void 0 ? {} : _this$config$data, withCredentials = _this$config.withCredentials, beforeUpload = _this$config.beforeUpload, onError = _this$config.onError;
                _context2.next = 5;
                return beforeUpload === null || beforeUpload === void 0 ? void 0 : beforeUpload(file);

              case 5:
                _file = _context2.sent;

                if (!(_file === false)) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt("return");

              case 8:
                if (_file instanceof File) file = _file;

                if (!(typeof data === 'function')) {
                  _context2.next = 13;
                  break;
                }

                _context2.next = 12;
                return data(file);

              case 12:
                data = _context2.sent;

              case 13:
                return _context2.abrupt("return", new Promise(function (resolve, reject) {
                  var xhr = new XMLHttpRequest();
                  xhr.timeout = timeout;

                  xhr.ontimeout = function (e) {
                    _this3.onError(xhr, file, view);

                    reject();
                  };

                  xhr.upload.onprogress = function (e) {
                    if (!_this3.onProgress(e, file, view)) {
                      xhr.abort();
                    }
                  };

                  xhr.onabort = function (e) {
                    _this3.onError(xhr, file, view);

                    reject();
                  };

                  xhr.onerror = function (e) {
                    _this3.onError(xhr, file, view);

                    reject();
                  };

                  xhr.onload = function () {
                    if (xhr.status === 200 || xhr.status === 201) {
                      _this3.onSuccess(xhr, file, view);

                      resolve();
                      return;
                    }

                    _this3.onError(xhr, file, view);

                    reject();
                  };

                  xhr.open('post', url, true);

                  if (withCredentials && 'withCredentials' in xhr) {
                    xhr.withCredentials = true;
                  }

                  Object.assign(headers, {
                    'X-Requested-With': 'XMLHttpRequest'
                  });
                  Object.entries(headers).forEach(function (_ref) {
                    var _ref2 = _slicedToArray(_ref, 2),
                        key = _ref2[0],
                        value = _ref2[1];

                    xhr.setRequestHeader(key, value);
                  });
                  var formData = new FormData();
                  Object.entries(data).map(function (_ref3) {
                    var _ref4 = _slicedToArray(_ref3, 2),
                        key = _ref4[0],
                        value = _ref4[1];

                    formData.append(key, value);
                  });
                  formData.append(name, file);
                  xhr.send(formData);

                  var content = _this3.parseTemplate(file, " Uploading... 0%");

                  _this3.intervalQueue(function () {
                    return _this3.updateTemplateContent(content, file, view);
                  });
                }));

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function upload(_x3, _x4) {
        return _upload.apply(this, arguments);
      }

      return upload;
    }()
  }, {
    key: "onProgress",
    value: function onProgress(e, file, view) {
      var _this4 = this;

      if (!this.existTemplateContent(file, view)) {
        return false;
      }

      var percent = e.loaded / e.total * 100;
      var content = this.parseTemplate(file, " Uploading... ".concat(percent, "%"));
      this.intervalQueue(function () {
        return _this4.updateTemplateContent(content, file, view);
      });
      return true;
    }
  }, {
    key: "getBody",
    value: function getBody(xhr) {
      var text = xhr.responseText || xhr.response;
      if (!text) return text;

      try {
        return JSON.parse(text);
      } catch (e) {
        return text;
      }
    }
  }, {
    key: "onSuccess",
    value: function onSuccess(xhr, file, view) {
      var _this5 = this;

      var _this$config2 = this.config,
          transform = _this$config2.transform,
          onSuccess = _this$config2.onSuccess;
      var res = this.getBody(xhr);

      var _ref5 = (transform === null || transform === void 0 ? void 0 : transform(res, xhr)) || res,
          url = _ref5.url,
          _ref5$title = _ref5.title,
          title = _ref5$title === void 0 ? 'image' : _ref5$title;

      var content = (this.isImage(file) ? '!' : '') + "[".concat(title, "](").concat(url, ")");
      this.intervalQueue(function () {
        if (_this5.existTemplateContent(file, view)) {
          return _this5.updateTemplateContent(content, file, view);
        }

        var changes = view.state.replaceSelection(content);
        view.dispatch(changes, {
          userEvent: 'input'
        });
      });
      onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(res, xhr, file);
    }
  }, {
    key: "onError",
    value: function onError(xhr, file, view) {
      var _this6 = this;

      var onError = this.config.onError;
      this.intervalQueue(function () {
        _this6.updateTemplateContent('', file, view);
      });
      onError === null || onError === void 0 ? void 0 : onError(xhr, file);
    }
  }]);

  return Uploader;
}();

var upload = function upload(config) {
  var uploader = new Uploader(config);
  return EditorView.domEventHandlers({
    paste: function paste(event, view) {
      var clipboardData = event.clipboardData;
      var files = [];

      if (clipboardData && _typeof(clipboardData) === 'object') {
        var items = clipboardData.items || clipboardData.files || [];

        var _iterator3 = _createForOfIteratorHelper(items),
            _step3;

        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var item = _step3.value;

            if (item instanceof DataTransferItem) {
              var file = item.getAsFile();

              if (item.kind !== 'string' && file) {
                files.push(file);
              }

              continue;
            }

            files.push(item);
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }

      if (files.length > 0) {
        event.preventDefault();
        uploader.uploadFiles(files, view);
      }
    },
    drop: function drop(event, view) {
      event.preventDefault();

      if (event.dataTransfer && event.dataTransfer.files.length > 0) {
        uploader.uploadFiles(event.dataTransfer.files, view);
      }
    }
  });
};

export default upload;