import React from 'react';
import './Preview.less';
export interface PreviewInstance {
  setMarkdown(markdown: string): void;
  debounceSetMarkdown(markdown: string): void;
}
export interface PreviewProps {
  /**
   * @description 自定义渲染
   */
  render?(markdown: string): React.ReactNode;
  /**
   * @description 刷新间隔
   */
  interval?: number;
  /**
   * @description 自动更新
   */
  shouldUpdate?: boolean;
  /**
   * @description remark 插件
   */
  remarkPlugins?: import('unified').PluggableList;
  /**
   * @description rehype 插件
   */
  rehypePlugins?: import('unified').PluggableList;
}
declare const _default: React.MemoExoticComponent<
  React.ForwardRefExoticComponent<PreviewProps & React.RefAttributes<PreviewInstance>>
>;
export default _default;
