'use strict';

function _typeof(obj) {
  '@babel/helpers - typeof';
  return (
    (_typeof =
      'function' == typeof Symbol && 'symbol' == typeof Symbol.iterator
        ? function (obj) {
            return typeof obj;
          }
        : function (obj) {
            return obj &&
              'function' == typeof Symbol &&
              obj.constructor === Symbol &&
              obj !== Symbol.prototype
              ? 'symbol'
              : typeof obj;
          }),
    _typeof(obj)
  );
}

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.default = void 0;

var _react = _interopRequireWildcard(require('react'));

var _classnames = _interopRequireDefault(require('classnames'));

var _debounce = _interopRequireDefault(require('lodash/debounce'));

var _reactMarkdown = _interopRequireDefault(require('react-markdown'));

var _remarkGfm = _interopRequireDefault(require('remark-gfm'));

var _remarkBreaks = _interopRequireDefault(require('remark-breaks'));

var _rehypeRaw = _interopRequireDefault(require('rehype-raw'));

var _rehypeSanitize = _interopRequireWildcard(require('rehype-sanitize'));

var _reactSyntaxHighlighter = require('react-syntax-highlighter');

var _prism = _interopRequireDefault(
  require('react-syntax-highlighter/dist/esm/styles/prism/prism'),
);

require('./Preview.css');

var _excluded = ['node', 'inline', 'className', 'children'];

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}

function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (_typeof(obj) !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly &&
      (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })),
      keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2
      ? ownKeys(Object(source), !0).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        })
      : Object.getOwnPropertyDescriptors
      ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
      : ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
  }
  return target;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true,
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function _toConsumableArray(arr) {
  return (
    _arrayWithoutHoles(arr) ||
    _iterableToArray(arr) ||
    _unsupportedIterableToArray(arr) ||
    _nonIterableSpread()
  );
}

function _nonIterableSpread() {
  throw new TypeError(
    'Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _iterableToArray(iter) {
  if (
    (typeof Symbol !== 'undefined' && iter[Symbol.iterator] != null) ||
    iter['@@iterator'] != null
  )
    return Array.from(iter);
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _slicedToArray(arr, i) {
  return (
    _arrayWithHoles(arr) ||
    _iterableToArrayLimit(arr, i) ||
    _unsupportedIterableToArray(arr, i) ||
    _nonIterableRest()
  );
}

function _nonIterableRest() {
  throw new TypeError(
    'Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === 'Object' && o.constructor) n = o.constructor.name;
  if (n === 'Map' || n === 'Set') return Array.from(o);
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  var _i =
    arr == null
      ? null
      : (typeof Symbol !== 'undefined' && arr[Symbol.iterator]) || arr['@@iterator'];
  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i['return'] != null) _i['return']();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var Preview = /*#__PURE__*/ (0, _react.forwardRef)(function (props, ref) {
  var _defaultSchema$attrib, _defaultSchema$attrib2;

  var render = props.render,
    _props$interval = props.interval,
    interval = _props$interval === void 0 ? 1000 : _props$interval,
    _props$remarkPlugins = props.remarkPlugins,
    remarkPlugins = _props$remarkPlugins === void 0 ? [] : _props$remarkPlugins,
    _props$rehypePlugins = props.rehypePlugins,
    rehypePlugins = _props$rehypePlugins === void 0 ? [] : _props$rehypePlugins;

  var _useState = (0, _react.useState)(''),
    _useState2 = _slicedToArray(_useState, 2),
    markdown = _useState2[0],
    setMarkdown = _useState2[1];

  var debounceSetMarkdown = (0, _react.useMemo)(
    function () {
      return (0, _debounce.default)(setMarkdown, interval);
    },
    [interval],
  );
  (0, _react.useImperativeHandle)(
    ref,
    function () {
      return {
        setMarkdown: setMarkdown,
        debounceSetMarkdown: debounceSetMarkdown,
      };
    },
    [debounceSetMarkdown],
  );
  return /*#__PURE__*/ _react.default.createElement(
    'div',
    {
      className: 'pf-mde-preview-content',
    },
    (render === null || render === void 0 ? void 0 : render(markdown)) ||
      /*#__PURE__*/ _react.default.createElement(_reactMarkdown.default, {
        children: markdown,
        remarkPlugins: [_remarkGfm.default, _remarkBreaks.default].concat(
          _toConsumableArray(remarkPlugins),
        ),
        rehypePlugins: [].concat(_toConsumableArray(rehypePlugins), [
          _rehypeRaw.default,
          [
            _rehypeSanitize.default,
            _objectSpread(
              _objectSpread({}, _rehypeSanitize.defaultSchema),
              {},
              {
                attributes: _objectSpread(
                  _objectSpread({}, _rehypeSanitize.defaultSchema.attributes),
                  {},
                  {
                    code: [].concat(
                      _toConsumableArray(
                        ((_defaultSchema$attrib = _rehypeSanitize.defaultSchema.attributes) ===
                          null || _defaultSchema$attrib === void 0
                          ? void 0
                          : _defaultSchema$attrib.code) || [],
                      ),
                      [['className']],
                    ),
                    span: [].concat(
                      _toConsumableArray(
                        ((_defaultSchema$attrib2 = _rehypeSanitize.defaultSchema.attributes) ===
                          null || _defaultSchema$attrib2 === void 0
                          ? void 0
                          : _defaultSchema$attrib2.span) || [],
                      ),
                      [['className']],
                    ),
                  },
                ),
              },
            ),
          ],
        ]),
        components: {
          code: function code(_ref) {
            var node = _ref.node,
              inline = _ref.inline,
              className = _ref.className,
              children = _ref.children,
              props = _objectWithoutProperties(_ref, _excluded);

            if (inline) {
              return /*#__PURE__*/ _react.default.createElement(
                'code',
                _objectSpread(
                  {
                    className: (0, _classnames.default)(className, 'pf-mde-inline-code'),
                  },
                  props,
                ),
                children,
              );
            }

            var match = /language-(\w+)/.exec(className || '');

            if (match) {
              return /*#__PURE__*/ _react.default.createElement(
                _reactSyntaxHighlighter.PrismAsyncLight,
                _objectSpread(
                  {
                    children: String(children).replace(/\n$/, ''),
                    style: _prism.default,
                    customStyle: {
                      borderRadius: 4,
                      background: '#f6f8fa',
                    },
                    language: match[1],
                    PreTag: 'div',
                  },
                  props,
                ),
              );
            }

            return /*#__PURE__*/ _react.default.createElement(
              'div',
              {
                className: 'pf-mde-block-code',
              },
              /*#__PURE__*/ _react.default.createElement(
                'code',
                _objectSpread(
                  {
                    className: className,
                  },
                  props,
                ),
                children,
              ),
            );
          },
        },
      }),
  );
});

var _default = /*#__PURE__*/ _react.default.memo(Preview, function (prevProps, nextProps) {
  return (
    !nextProps.shouldUpdate ||
    (prevProps.render === nextProps.render && prevProps.interval === nextProps.interval)
  );
});

exports.default = _default;
