'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.indent =
  exports.image =
  exports.heading6 =
  exports.heading5 =
  exports.heading4 =
  exports.heading3 =
  exports.heading2 =
  exports.heading1 =
  exports.heading =
  exports.code =
  exports.bold =
    void 0;
Object.defineProperty(exports, 'indentLess', {
  enumerable: true,
  get: function get() {
    return _commands.indentLess;
  },
});
exports.unorderedList =
  exports.table =
  exports.strikethrough =
  exports.quote =
  exports.orderedList =
  exports.link =
  exports.line =
  exports.italic =
    void 0;

var _langMarkdown = require('@codemirror/lang-markdown');

var _language = require('@codemirror/language');

var _state = require('@codemirror/state');

var _autocomplete = require('@codemirror/autocomplete');

var _commands = require('@codemirror/commands');

function _toConsumableArray(arr) {
  return (
    _arrayWithoutHoles(arr) ||
    _iterableToArray(arr) ||
    _unsupportedIterableToArray(arr) ||
    _nonIterableSpread()
  );
}

function _nonIterableSpread() {
  throw new TypeError(
    'Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _iterableToArray(iter) {
  if (
    (typeof Symbol !== 'undefined' && iter[Symbol.iterator] != null) ||
    iter['@@iterator'] != null
  )
    return Array.from(iter);
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _slicedToArray(arr, i) {
  return (
    _arrayWithHoles(arr) ||
    _iterableToArrayLimit(arr, i) ||
    _unsupportedIterableToArray(arr, i) ||
    _nonIterableRest()
  );
}

function _nonIterableRest() {
  throw new TypeError(
    'Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === 'Object' && o.constructor) n = o.constructor.name;
  if (n === 'Map' || n === 'Set') return Array.from(o);
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  var _i =
    arr == null
      ? null
      : (typeof Symbol !== 'undefined' && arr[Symbol.iterator]) || arr['@@iterator'];
  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i['return'] != null) _i['return']();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function isMultipleLines(doc, from, to) {
  return doc.lineAt(from).to < to;
}

function toggleInline(view, nodeName, markString) {
  var state = view.state,
    dispatch = view.dispatch;
  if (state.readOnly) return false;
  var tree = (0, _language.syntaxTree)(state);
  var dont = null;
  var changes = state.changeByRange(function (range) {
    var _node, _node2;

    if (isMultipleLines(state.doc, range.from, range.to))
      return (dont = {
        range: range,
      });
    if (!_langMarkdown.markdownLanguage.isActiveAt(state, range.from))
      return (dont = {
        range: range,
      });
    var node = tree.resolveInner(range.from);
    if (['URL', 'Image', 'Link', 'LinkMark', 'LinkTitle'].includes(node.name))
      return (dont = {
        range: range,
      });
    if (!range.empty && ['Document', 'Paragraph'].includes(node.name))
      node = tree.resolveInner(range.from, 1);

    while (![nodeName, 'Paragraph'].includes(node.name) && node.parent) {
      node = node.parent;
    }

    if (node.name === nodeName && node.to >= range.to) {
      var startMarkNode = node.firstChild;
      var endMarkNode = node.lastChild;
      var anchor =
        Math.min(Math.max(range.anchor, startMarkNode.to), endMarkNode.from) -
        startMarkNode.to +
        startMarkNode.from;
      var head =
        Math.min(Math.max(range.head, startMarkNode.to), endMarkNode.from) -
        startMarkNode.to +
        startMarkNode.from;
      return {
        changes: [
          {
            from: startMarkNode.from,
            to: startMarkNode.to,
          },
          {
            from: endMarkNode.from,
            to: endMarkNode.to,
          },
        ],
        range: _state.EditorSelection.range(anchor, head),
      };
    }

    node = getCodeNode(view, range.from);
    if (
      ((_node = node) === null || _node === void 0 ? void 0 : _node.name) === 'CodeBlock' ||
      ((_node2 = node) === null || _node2 === void 0 ? void 0 : _node2.name) === 'FencedCode'
    )
      return (dont = {
        range: range,
      });
    var fromNode = tree.resolveInner(range.from);
    var toNode = tree.resolveInner(range.to);

    if (fromNode !== toNode) {
      if (
        [fromNode.name, toNode.name].some(function (name) {
          return ![
            'Document',
            'Paragraph',
            'Blockquote',
            'BulletList',
            'OrderedList',
            'ListItem',
            'ATXHeading1',
            'ATXHeading2',
            'ATXHeading3',
            'ATXHeading4',
            'ATXHeading5',
            'ATXHeading6',
            'SetextHeading1',
            'SetextHeading2',
          ].includes(name);
        })
      ) {
        return (dont = {
          range: range,
        });
      }
    }

    return {
      changes: [
        {
          from: range.from,
          insert: markString,
        },
        {
          from: range.to,
          insert: markString,
        },
      ],
      range: _state.EditorSelection.range(
        range.anchor + markString.length,
        range.head + markString.length,
      ),
    };
  });
  if (changes.changes.empty) return false;
  dispatch(
    state.update(changes, {
      userEvent: 'toggle.'.concat(nodeName),
    }),
  );
  return !dont;
}

function toggleHeading(view, level) {
  var state = view.state,
    dispatch = view.dispatch;
  if (state.readOnly) return false;
  var tree = (0, _language.syntaxTree)(state);
  var changes = state.changeByRange(function (range) {
    var changes = [];

    for (var pos = range.from; pos <= range.to; ) {
      var _line = state.doc.lineAt(pos);

      do {
        var _node3, _node4;

        if (!_langMarkdown.markdownLanguage.isActiveAt(state, pos)) break;
        var node = tree.resolveInner(_line.to, -1);

        while (node && !node.name.startsWith('ATXHeading')) {
          node = node.parent;
        }

        node = ((_node3 = node) === null || _node3 === void 0 ? void 0 : _node3.firstChild) || null;

        if (
          ((_node4 = node) === null || _node4 === void 0 ? void 0 : _node4.name) === 'HeaderMark'
        ) {
          var toLevel = level || (node.to - node.from + 1) % 7;
          changes.push(
            {
              from: _line.from,
              to: node.to,
              insert: ''.concat('#'.repeat(toLevel)).concat(toLevel ? ' ' : ''),
            },
            {
              from: node.to,
              to: _line.to,
              insert: state.sliceDoc(node.to, _line.to).trimStart(),
            },
          );
        } else {
          var _node5, _node6;

          node = getCodeNode(view, _line.to, true);
          if (
            ((_node5 = node) === null || _node5 === void 0 ? void 0 : _node5.name) ===
              'CodeBlock' ||
            ((_node6 = node) === null || _node6 === void 0 ? void 0 : _node6.name) === 'FencedCode'
          )
            break;

          var _toLevel = level || 1;

          changes.push({
            from: _line.from,
            to: _line.to,
            insert: ''.concat('#'.repeat(_toLevel), ' ').concat(_line.text.trimStart()),
          });
        }
      } while (false);

      pos = _line.to + 1;
    }

    var changeSet = state.changes(changes);
    return {
      changes: changes,
      range: _state.EditorSelection.range(
        changeSet.mapPos(range.anchor, 1),
        changeSet.mapPos(range.head, 1),
      ),
    };
  });
  if (changes.changes.empty) return false;
  dispatch(
    state.update(changes, {
      userEvent: 'toggle.heading',
    }),
  );
  return true;
}

function toggleBlock(view, type) {
  var state = view.state,
    dispatch = view.dispatch;
  if (state.readOnly) return false;
  var regExp = {
    quote: /^(\s*)>\s+/,
    unorderedList: /^(\s*)([*-+])\s+/,
    orderedList: /^(\s*)\d+\.\s+/,
  }[type];
  var changes = state.changeByRange(function (range) {
    var changes = [];
    var exist = regExp.test(state.doc.lineAt(range.from).text);

    for (var pos = range.from, i = 1; pos <= range.to; ) {
      var _getCodeNode;

      var _line2 = state.doc.lineAt(pos);

      if (
        ((_getCodeNode = getCodeNode(view, _line2.to, true)) === null || _getCodeNode === void 0
          ? void 0
          : _getCodeNode.name) === 'FencedCode'
      ) {
        changes = [];
        break;
      }

      var mark = {
        quote: '> ',
        unorderedList: '* ',
        orderedList: ''.concat(i, '. '),
      }[type];
      var text = exist ? _line2.text.replace(regExp, '$1') : ''.concat(mark).concat(_line2.text);
      changes.push({
        from: _line2.from,
        to: _line2.to,
        insert: text,
      });
      i++;
      pos = _line2.to + 1;
    }

    var changeSet = state.changes(changes);
    return {
      changes: changes,
      range: _state.EditorSelection.range(
        changeSet.mapPos(range.anchor, 1),
        changeSet.mapPos(range.head, 1),
      ),
    };
  });
  if (changes.changes.empty) return false;
  dispatch(
    state.update(changes, {
      userEvent: 'toggle.heading',
    }),
  );
  return true;
}

function getCodeNode(view, pos) {
  var lineEndPos = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var state = view.state;
  var tree = (0, _language.syntaxTree)(state);
  var node = tree.resolve(pos, lineEndPos ? -1 : 0);

  do {
    if (
      (node.name === 'InlineCode' && !lineEndPos) ||
      ['CodeBlock', 'FencedCode'].includes(node.name)
    ) {
      return node;
    }
  } while ((node = node.parent));

  if (!lineEndPos) {
    var _line3 = state.doc.lineAt(pos);

    if (pos !== _line3.to - 1) {
      return getCodeNode(view, _line3.to, true);
    }
  }

  return null;
}

function insertTemplate(view, template) {
  var state = view.state;
  if (state.readOnly || state.selection.ranges.length > 1) return false;

  var _state$selection$rang = _slicedToArray(state.selection.ranges, 1),
    range = _state$selection$rang[0];

  if (!_langMarkdown.markdownLanguage.isActiveAt(state, range.from)) return false;

  if (
    _toConsumableArray(new Set([range.from, range.to])).some(function (pos) {
      var node = getCodeNode(view, pos);

      if (
        (node === null || node === void 0 ? void 0 : node.name) === 'CodeBlock' ||
        (node === null || node === void 0 ? void 0 : node.name) === 'FencedCode'
      ) {
        return pos >= node.from && pos <= node.to;
      }
    })
  ) {
    return false;
  }

  var fn = (0, _autocomplete.snippet)(template);
  fn(view, null, range.from, range.to);
  return true;
}

function newLineAndReplaceSelection(view) {
  var text = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var state = view.state,
    dispatch = view.dispatch;
  var changes = state.changeByRange(function (range) {
    if (
      _toConsumableArray(new Set([range.from, range.to])).some(function (pos) {
        var node = getCodeNode(view, pos);

        if (
          (node === null || node === void 0 ? void 0 : node.name) === 'CodeBlock' ||
          (node === null || node === void 0 ? void 0 : node.name) === 'FencedCode'
        ) {
          return pos > node.from && pos < node.to;
        }

        return false;
      })
    ) {
      return {
        range: range,
      };
    }

    var changes = [];
    var replacement = text;
    var fromLine = state.doc.lineAt(range.from);
    var toLine = state.doc.lineAt(range.to);

    if (range.from > fromLine.from && !/^\s*$/.test(state.sliceDoc(fromLine.from, range.from))) {
      replacement = '\n\n' + replacement;
    } else if (fromLine.number > 1) {
      var _line4 = state.doc.line(fromLine.number - 1);

      if (!/^\s*$/.test(_line4.text)) {
        replacement = '\n' + replacement;
      }
    }

    var selection = _state.EditorSelection.cursor(range.from + replacement.length + 2);

    if (!/^\s*$/.test(state.sliceDoc(range.to, toLine.to))) {
      replacement += '\n\n';
    } else if (toLine.number === state.doc.lines) {
      replacement += '\n\n';
    } else {
      var _line5 = state.doc.line(toLine.number + 1);

      if (/^\s*$/.test(_line5.text)) {
        replacement += '\n';
      } else {
        replacement += '\n\n';
      }
    }

    changes.push({
      from: range.from,
      to: range.to,
      insert: replacement,
    });
    return {
      changes: changes,
      range: selection,
    };
  });
  if (changes.changes.empty) return false;
  dispatch(
    state.update(changes, {
      userEvent: 'toggle.heading',
    }),
  );
  return true;
}

var bold = function bold(view) {
  return toggleInline(view, 'StrongEmphasis', '**');
};

exports.bold = bold;

var italic = function italic(view) {
  return toggleInline(view, 'Emphasis', '_');
};

exports.italic = italic;

var strikethrough = function strikethrough(view) {
  return toggleInline(view, 'Strikethrough', '~~');
};

exports.strikethrough = strikethrough;

var heading = function heading(view) {
  return toggleHeading(view);
};

exports.heading = heading;

var heading1 = function heading1(view) {
  return toggleHeading(view, 1);
};

exports.heading1 = heading1;

var heading2 = function heading2(view) {
  return toggleHeading(view, 2);
};

exports.heading2 = heading2;

var heading3 = function heading3(view) {
  return toggleHeading(view, 3);
};

exports.heading3 = heading3;

var heading4 = function heading4(view) {
  return toggleHeading(view, 4);
};

exports.heading4 = heading4;

var heading5 = function heading5(view) {
  return toggleHeading(view, 5);
};

exports.heading5 = heading5;

var heading6 = function heading6(view) {
  return toggleHeading(view, 6);
};

exports.heading6 = heading6;

var code = function code(view) {
  var state = view.state,
    dispatch = view.dispatch;
  if (state.readOnly) return false;

  if (state.selection.ranges.length > 1) {
    return toggleInline(view, 'InlineCode', '`');
  }

  var range = state.selection.ranges[0];
  var node = getCodeNode(view, range.from);
  var line = state.doc.lineAt(range.from);
  var selMulti = isMultipleLines(state.doc, range.from, range.to);
  var noSelAndStartingOfLine = range.empty && range.from === line.from;
  var changes = [];
  var selection = undefined;

  if (
    !selMulti &&
    ((node === null || node === void 0 ? void 0 : node.name) === 'InlineCode' ||
      (!node && !noSelAndStartingOfLine))
  ) {
    return toggleInline(view, 'InlineCode', '`');
  }

  if ((node === null || node === void 0 ? void 0 : node.name) === 'CodeBlock') {
    for (var pos = node.from; pos <= node.to; ) {
      var _line6 = state.doc.lineAt(pos);

      var space = /^\s*/.exec(_line6.text)[0];

      if (space) {
        var tabFlag = false;

        for (var j = 0; j < space.length; j++) {
          if (space.charCodeAt(j) === 9) {
            // \t
            tabFlag = true;
            changes.push({
              from: _line6.from + j,
              to: _line6.from + j + 1,
            });
            break;
          }
        }

        if (!tabFlag) {
          changes.push({
            from: _line6.from,
            to: _line6.from + 4,
          });
        }
      }

      pos = _line6.to + 1;
    }
  } else if ((node === null || node === void 0 ? void 0 : node.name) === 'FencedCode') {
    if (node.to < range.to) return false;
    changes.push(
      {
        from: node.from,
        to: state.doc.lineAt(node.from).to + 1,
      },
      {
        from: state.doc.lineAt(node.to).from - 1,
        to: node.to,
      },
    );
  } else {
    if (range.to > line.to) {
      for (var _pos = line.to + 1; _pos <= range.to; ) {
        var _getCodeNode2;

        var _line7 = state.doc.lineAt(_pos);

        if (
          ((_getCodeNode2 = getCodeNode(view, _pos)) === null || _getCodeNode2 === void 0
            ? void 0
            : _getCodeNode2.name) === 'FencedCode'
        )
          return false;
        _pos = _line7.to + 1;
      }
    }

    changes.push(
      {
        from: range.from,
        insert: '```\n',
      },
      {
        from: range.to,
        insert: '\n```',
      },
    );
    selection = _state.EditorSelection.range(range.anchor + 4, range.head + 4);
  }

  dispatch({
    changes: changes,
    selection: selection,
  });
  return true;
}; // todo 有！前缀中文输入有bug

exports.code = code;

var image = function image(view) {
  return insertTemplate(view, '![${alt}](${url} "${title}") ${}');
};

exports.image = image;

var link = function link(view) {
  return insertTemplate(view, '[${link}](${url}) ${}');
};

exports.link = link;

var line = function line(view) {
  return newLineAndReplaceSelection(view, '-----');
};

exports.line = line;

var table = function table(view) {
  return newLineAndReplaceSelection(
    view,
    '| Column 1 | Column 2 | Column 3 |\n| -------- | -------- | -------- |\n| Text     | Text     | Text     |',
  );
};

exports.table = table;

var quote = function quote(view) {
  return toggleBlock(view, 'quote');
};

exports.quote = quote;

var orderedList = function orderedList(view) {
  return toggleBlock(view, 'orderedList');
};

exports.orderedList = orderedList;

var unorderedList = function unorderedList(view) {
  return toggleBlock(view, 'unorderedList');
};

exports.unorderedList = unorderedList;

var indent = function indent(view) {
  var state = view.state,
    dispatch = view.dispatch;
  var changes = state.changeByRange(function (range) {
    var changes = [];

    if (range.from < range.to) {
      for (var pos = range.from; pos <= range.to; ) {
        var _line8 = state.doc.lineAt(pos);

        changes.push({
          from: _line8.from,
          insert: state.facet(_language.indentUnit),
        });
        pos = _line8.to + 1;
      }
    } else {
      changes.push({
        from: range.from,
        insert: state.facet(_language.indentUnit),
      });
    }

    var changeSet = state.changes(changes);
    return {
      changes: changes,
      range: _state.EditorSelection.range(
        changeSet.mapPos(range.anchor, 1),
        changeSet.mapPos(range.head, 1),
      ),
    };
  });
  if (changes.changes.empty) return false;
  dispatch(
    state.update(changes, {
      userEvent: 'indent',
    }),
  );
  return true;
};

exports.indent = indent;
