import { MutableRefObject } from 'react';
import { Extension } from '@codemirror/state';
import { EditorView, ViewUpdate } from '@codemirror/view';
export interface UseCodeMirrorProps {
  /**
   * @description 挂载节点
   */
  containerRef: MutableRefObject<HTMLDivElement | null>;
  /**
   * @description 编辑器内容
   */
  value?: string;
  /**
   * @description 高度
   */
  height?: string;
  /**
   * @description 最小高度
   */
  minHeight?: string;
  /**
   * @description 最大高度
   */
  maxHeight?: string;
  /**
   * @description [codemirror 扩展](https://codemirror.net/6/)
   */
  extensions?: Extension[];
  /**
   * @description 内容变化时的回调
   */
  onChange?(value: string, viewUpdate: ViewUpdate): void;
  /**
   * @description 状态更新时的回调
   */
  onUpdate?(viewUpdate: ViewUpdate): void;
}
declare const _default: (props: UseCodeMirrorProps) => MutableRefObject<EditorView | null>;
export default _default;
