'use strict';

function _typeof(obj) {
  '@babel/helpers - typeof';
  return (
    (_typeof =
      'function' == typeof Symbol && 'symbol' == typeof Symbol.iterator
        ? function (obj) {
            return typeof obj;
          }
        : function (obj) {
            return obj &&
              'function' == typeof Symbol &&
              obj.constructor === Symbol &&
              obj !== Symbol.prototype
              ? 'symbol'
              : typeof obj;
          }),
    _typeof(obj)
  );
}

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.default = void 0;

var _react = require('react');

var _state = require('@codemirror/state');

var _view = require('@codemirror/view');

var _langMarkdown = require('@codemirror/lang-markdown');

var _languageData = require('@codemirror/language-data');

var commands = _interopRequireWildcard(require('../commands'));

function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}

function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (_typeof(obj) !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}

// console.info(require('@codemirror/view'));
console.info(
  'keymap',
  _view.keymap,
  _view.keymap === null || _view.keymap === void 0 ? void 0 : _view.keymap.of,
);

var _default = function _default(props) {
  var containerRef = props.containerRef,
    value = props.value,
    _props$height = props.height,
    height = _props$height === void 0 ? '' : _props$height,
    _props$minHeight = props.minHeight,
    minHeight = _props$minHeight === void 0 ? '' : _props$minHeight,
    _props$maxHeight = props.maxHeight,
    maxHeight = _props$maxHeight === void 0 ? '' : _props$maxHeight,
    onChange = props.onChange,
    onUpdate = props.onUpdate;
  var editorViewRef = (0, _react.useRef)(null);
  var onChangeRef = (0, _react.useRef)();
  var onUpdateRef = (0, _react.useRef)();
  onChangeRef.current = onChange;
  onUpdateRef.current = onUpdate;
  var extensions = (0, _react.useMemo)(
    function () {
      return (props.extensions || []).concat([
        _view.keymap.of([
          {
            key: 'Tab',
            run: commands.indent,
            shift: commands.indentLess,
          },
          {
            key: 'Mod-b',
            run: commands.bold,
          },
          {
            key: 'Mod-i',
            run: commands.italic,
          },
          {
            key: 'Mod-h',
            run: commands.heading,
          },
          {
            key: 'Mod-Alt-i',
            run: commands.image,
          },
          {
            key: "Mod-'",
            run: commands.quote,
          },
          {
            key: 'Mod-Alt-c',
            run: commands.code,
          },
          {
            key: 'Mod-l',
            run: commands.unorderedList,
          },
          {
            key: 'Mod-Alt-l',
            run: commands.orderedList,
          },
        ]),
        (0, _langMarkdown.markdown)({
          codeLanguages: _languageData.languages,
          base: _langMarkdown.markdownLanguage,
        }),
        _view.EditorView.theme({
          '&': {
            height: height,
            minHeight: minHeight,
            maxHeight: maxHeight,
          },
        }),
        _view.EditorView.updateListener.of(function (viewUpdate) {
          var _onUpdateRef$current;

          if (viewUpdate.docChanged) {
            var _onChangeRef$current;

            var _value = viewUpdate.state.doc.toString();

            (_onChangeRef$current = onChangeRef.current) === null || _onChangeRef$current === void 0
              ? void 0
              : _onChangeRef$current.call(onChangeRef, _value, viewUpdate);
          }

          (_onUpdateRef$current = onUpdateRef.current) === null || _onUpdateRef$current === void 0
            ? void 0
            : _onUpdateRef$current.call(onUpdateRef, viewUpdate);
        }), // todo placeholder 会导致起始位置无法输入中文
      ]);
    },
    [height, minHeight, minHeight, props.extensions],
  ); // reconfigure

  (0, _react.useEffect)(
    function () {
      var _editorViewRef$curren;

      // todo 样式会一直累加
      (_editorViewRef$curren = editorViewRef.current) === null || _editorViewRef$curren === void 0
        ? void 0
        : _editorViewRef$curren.dispatch({
            effects: _state.StateEffect.reconfigure.of(extensions),
          });
    },
    [extensions],
  ); // value change

  (0, _react.useEffect)(
    function () {
      var _editorViewRef$curren2;

      var currentValue =
        (_editorViewRef$curren2 = editorViewRef.current) === null ||
        _editorViewRef$curren2 === void 0
          ? void 0
          : _editorViewRef$curren2.state.doc.toString();

      if (value !== currentValue) {
        var _editorViewRef$curren3;

        (_editorViewRef$curren3 = editorViewRef.current) === null ||
        _editorViewRef$curren3 === void 0
          ? void 0
          : _editorViewRef$curren3.dispatch({
              changes: {
                from: 0,
                to: currentValue === null || currentValue === void 0 ? void 0 : currentValue.length,
                insert: value,
              },
            });
      }
    },
    [value],
  ); // 编辑器初始化

  (0, _react.useEffect)(function () {
    // todo 第一次 setState containerRef.current 值会变
    if (containerRef.current) {
      var state = _state.EditorState.create({
        doc: value,
        extensions: extensions,
      });

      editorViewRef.current = new _view.EditorView({
        state: state,
        parent: containerRef.current,
      });
      return function () {
        var _editorViewRef$curren4;

        (_editorViewRef$curren4 = editorViewRef.current) === null ||
        _editorViewRef$curren4 === void 0
          ? void 0
          : _editorViewRef$curren4.destroy();
      };
    }
  }, []);
  return editorViewRef;
};

exports.default = _default;
